## qemu-server 8.3.0

=== PVE/Makefile ===
PERLSOURCE = 			\
	QemuServer.pm		\
	QemuMigrate.pm		\
	QMPClient.pm		\
	QemuConfig.pm

.PHONY: install
install:
	install -d ${DESTDIR}${PERLDIR}/PVE
	install -m 0644 ${PERLSOURCE} ${DESTDIR}${PERLDIR}/PVE/
	$(MAKE) -C VZDump install
	$(MAKE) -C API2 install
	$(MAKE) -C CLI install
	$(MAKE) -C QemuServer install

=== qmeventd/Makefile ===
DESTDIR=
PREFIX=/usr
SBINDIR=${PREFIX}/sbin
SERVICEDIR=/lib/systemd/system
MANDIR=${PREFIX}/share/man

export NOVIEW=1
include /usr/share/pve-doc-generator/pve-doc-generator.mk

CC ?= gcc
CFLAGS += -O2 -Werror -Wall -Wextra -Wpedantic -Wtype-limits -Wl,-z,relro -std=gnu11
CFLAGS += $(shell pkg-config --cflags json-c glib-2.0)
LDFLAGS += $(shell pkg-config --libs json-c glib-2.0)

qmeventd: qmeventd.c
	$(CC) $(CFLAGS) -o $@ $< $(LDFLAGS)

docs: qmeventd.8

.PHONY: install
install: qmeventd docs
	install -d ${DESTDIR}/${SBINDIR}
	install -d ${DESTDIR}${SERVICEDIR}
	install -d ${DESTDIR}${MANDIR}/man8
	install -m 0644 qmeventd.service ${DESTDIR}${SERVICEDIR}
	install -m 0755 qmeventd ${DESTDIR}${SBINDIR}
	install -m 0644 qmeventd.8 ${DESTDIR}/${MANDIR}/man8

.PHONY: clean
clean:
	$(MAKE) cleanup-docgen
	rm -rf qmeventd

=== query-machine-capabilities/Makefile ===
DESTDIR=
PREFIX=/usr
BINDIR=${PREFIX}/libexec/qemu-server
SERVICEDIR=/lib/systemd/system

CC ?= gcc
CFLAGS += -O2 -fanalyzer -Werror -Wall -Wextra -Wpedantic -Wtype-limits -Wl,-z,relro -std=gnu11

query-machine-capabilities: query-machine-capabilities.c
	$(CC) $(CFLAGS) -o $@ $< $(LDFLAGS)

.PHONY: install
install: query-machine-capabilities
	install -d ${DESTDIR}/${BINDIR}
	install -m 0755 query-machine-capabilities ${DESTDIR}${BINDIR}
	install -m 0644 pve-query-machine-capabilities.service ${DESTDIR}${SERVICEDIR}

.PHONY: clean
clean:
	rm -f query-machine-capabilities

=== PVE/CLI/Makefile ===
SOURCES=qm.pm qmrestore.pm

.PHONY: install
install: ${SOURCES}
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/CLI
	for i in ${SOURCES}; do install -D -m 0644 $$i ${DESTDIR}${PERLDIR}/PVE/CLI/$$i; done

=== PVE/VZDump/Makefile ===

.PHONY: install
install:
	install -D -m 0644 QemuServer.pm ${DESTDIR}${PERLDIR}/PVE/VZDump/QemuServer.pm

=== debian/changelog ===
qemu-server (8.3.0) bookworm; urgency=medium

  * api: import working storage: improve error message

  * migration: drop outdated check that was introduced for PVE 7.2 to PVE 7.3
    to guard against (relatively low) fallout of the newly introduced
    cloudinit section in the VM config. This check can sometimes trigger as
    false-positive.

 -- Proxmox Support Team <support@proxmox.com>  Wed, 20 Nov 2024 12:12:00 +0100

qemu-server (8.2.7) bookworm; urgency=medium

  * backup: cleanup: check if VM is running before issuing QMP commands

  * restore: die early when there is no size for a device

  * add tiny C program to query some hardware capabilities from CPUID

  * backup: prepare: cancel previous job if still running, which can happen
    after a hard failure, e.g. if the vzdump task was canceled.

  * parse config: allow config keys with minus sign

  * import disk: add 'target-disk' option to add imported volume to disk

  * import disk: convert imported volume disks to base images for templates

  * fix #5301: convert added volume disks to base image for templates

  * use OVF module from the pve-storage package, it was moved over there

  * api: create: implement extracting disks when needed for import-from

  * api: create: add 'import-working-storage' parameter for overriding the
    staging directory used to extract to-be-imported disks.

  * api: check untrusted image files for the new import content type for
    proactive hardening.

  * config: add initial AMD SEV support

  * migration: add amd-sev to non-migratable resources blockers

 -- Proxmox Support Team <support@proxmox.com>  Mon, 18 Nov 2024 21:48:24 +0100

qemu-server (8.2.6) bookworm; urgency=medium

  * vm start: add syslog info with which PID a VM process was started

  * pci: avoid the hard requirement for a passthrough device to be reset on
    start to fix a recent regression from improving error handling from the
    pve-common package.

 -- Proxmox Support Team <support@proxmox.com>  Mon, 11 Nov 2024 20:38:25 +0100

qemu-server (8.2.5) bookworm; urgency=medium

  * remote migration: fix online migration via API clients

  * fix #5714: fix calloc parameter ordering

  * fix typos in user-visible strings

  * api: status: add some missing description for status return properties

  * pci: device selection: don't reserve PCI IDs when VM is already running to
    avoid false-positive if, e.g., one is checking the generated QEMU command
    using `qm showcmd`.

  * pci: mdev: adapt to NVIDIA's modern interface with kernel >= 6.8

 -- Proxmox Support Team <support@proxmox.com>  Thu, 24 Oct 2024 18:55:37 +0200

qemu-server (8.2.4) bookworm; urgency=medium

  * fix #5528: ensure cgroup limits like CPU weight are set correctly and in
    the same way for both cases, the cold-start and when changing while the VM
    is running

  * fix #5619: honor link-down setting when hot-plugging NIC

  * resume: bump timeout for query-status, as activating the block drives in
    QEMU on resume can take a bit of time during which the QEMU process might
    not respond to QMP commands yet.

  * fix #4493: cloud-init: fix generated Windows config

  * drive mirror: prevent wrongly logging success when completion fails for
    some other reasons than for which it's safe to retry on.

  * migration: avoid crash with heavy IO on migrating a disk backed by local
    storage, if the VM is running QEMU 8.2 or newer.

 -- Proxmox Support Team <support@proxmox.com>  Tue, 30 Jul 2024 21:36:25 +0200

qemu-server (8.2.3) bookworm; urgency=medium

  * config: net: avoid duplicate ipam entries on nic update

  * fix #5574: api: fix permission check for 'spice' usb port

 -- Proxmox Support Team <support@proxmox.com>  Mon, 22 Jul 2024 19:42:15 +0200

qemu-server (8.2.2) bookworm; urgency=medium

  * schema: mention that migrate_downtime parameter will be auto-increased if
    migration cannot converge otherwise.

  * remote migration: enable schema validation

  * suspend: also cleanup in error scenario when QMP command 'savevm-end'
    fails rather than leaving orphaned volume around and VM configuration
    locked.

  * human monitor commands: increase timeout to sensible values. In particular
    to fix #5440 where detaching a fleecing image would fail, because of the
    low timeout.

  * vma restore: increase timeout for reading header and improve error
    messages.

  * fix #5562: improve TPM version handling by disallowing change in the
    configuration after creation of the state file (the actual state file
    cannot change version either). Also avoid warning about undefined value
    when version is not explicitly set and fix schema to mention the actual
    default for the version, being 'v1.2'.

  * fix #3352: minimize config when starting templates for PBS backup. A
    template might reside on a host that does not have the necessary resources
    or devices to start the VM with all settings.

  * block jobs: improve error handling and messages for drive mirror and
    live-restore/live-import.

  * fix #5572: avoid warning about uninitialized value when cloning cloud-init
    disk.

  * CLI autocomplete: also list backup archives from PBS storages and without
    compressor extension.

  * remove outdated QEMU version checks working around missing features in
    QEMU binaries 4.2 and 4.0.1.

  * vga: mention that type 'cirrus' is recommended against.

 -- Proxmox Support Team <support@proxmox.com>  Fri, 12 Jul 2024 16:09:25 +0200

qemu-server (8.2.1) bookworm; urgency=medium

  * cpu config: fix get_cpu_bitness always reverting to default cpu type

 -- Proxmox Support Team <support@proxmox.com>  Wed, 24 Apr 2024 11:49:03 +0200

qemu-server (8.2.0) bookworm; urgency=medium

  * qmeventd: also treat 'prelaunch' and 'suspended' states as active to avoid
    issues when backing up VMs that currently are in those states.

  * OS type: add Windows Server 2025 as supported, map it to the same virtual


=== debian/control ===
Source: qemu-server
Section: admin
Priority: optional
Maintainer: Proxmox Support Team <support@proxmox.com>
Build-Depends: debhelper-compat (= 13),
               libglib2.0-dev,
               libio-multiplex-perl,
               libjson-c-dev,
               libpve-apiclient-perl,
               libpve-cluster-perl,
               libpve-common-perl (>= 8.0.2),
               libpve-guest-common-perl (>= 5.1.0),
               libpve-storage-perl (>= 8.2.8),
               libtest-mockmodule-perl,
               liburi-perl,
               libuuid-perl,
               lintian,
               perl,
               pkg-config,
               pve-cluster,
               pve-doc-generator (>= 6.2-5),
               pve-edk2-firmware,
               pve-edk2-firmware-aarch64,
               pve-firewall,
               pve-ha-manager <!nocheck>,
               pve-qemu-kvm (>= 7.1~),
Standards-Version: 4.5.1
Homepage: https://www.proxmox.com

Package: qemu-server
Architecture: any
Depends: dbus,
         genisoimage,
         libio-multiplex-perl,
         libjson-perl,
         libjson-xs-perl,
         libnet-ssleay-perl,
         libpve-access-control (>= 8.0.0~),
         libpve-apiclient-perl,
         libpve-cluster-perl,
         libpve-common-perl (>= 8.2.6),
         libpve-guest-common-perl (>= 5.1.2),
         libpve-storage-perl (>= 8.2.8),
         libterm-readline-gnu-perl,
         liburi-perl,
         libuuid-perl,
         perl (>= 5.10.0-19),
         proxmox-websocket-tunnel,
         pve-cluster,
# TODO: make legacy edk2 optional (suggests) for PVE 9 and warn explicitly about it
         pve-edk2-firmware-legacy | pve-edk2-firmware (<< 4~),
         pve-edk2-firmware-ovmf | pve-edk2-firmware (>= 3.20210831-1),
         pve-edk2-firmware-aarch64,
         pve-firewall (>= 5.0.4),
         pve-ha-manager (>= 3.0-9),
         pve-qemu-kvm (>= 7.1~),
         socat,
         swtpm,
         swtpm-tools,
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends},
Recommends: proxmox-backup-file-restore (>= 2.1.9-2),
            libpve-network-perl (>= 0.8.3),
Suggests: pve-edk2-firmware-aarch64, pve-edk2-firmware-riscv,
Breaks: pve-ha-manager (<< 4.0.1), pve-manager (<= 6.0-13),
Description: Qemu Server Tools
 This package contains the Qemu Server tools used by Proxmox VE

## qemu-server 8.3.3+port3

=== Makefile ===
include /usr/share/dpkg/default.mk

PACKAGE=qemu-server
BUILDDIR ?= $(PACKAGE)-$(DEB_VERSION_UPSTREAM)

DESTDIR=
PREFIX=/usr
SBINDIR=$(PREFIX)/sbin
LIBDIR=$(PREFIX)/lib/$(PACKAGE)
MANDIR=$(PREFIX)/share/man
DOCDIR=$(PREFIX)/share/doc
MAN1DIR=$(MANDIR)/man1/
MAN5DIR=$(MANDIR)/man5/
BASHCOMPLDIR=$(PREFIX)/share/bash-completion/completions/
ZSHCOMPLDIR=$(PREFIX)/share/zsh/vendor-completions/
export PERLDIR=$(PREFIX)/share/perl5
PERLINCDIR=$(PERLDIR)/asm-aarch64

GITVERSION:=$(shell git rev-parse HEAD)

DEB=$(PACKAGE)_$(DEB_VERSION_UPSTREAM_REVISION)_$(DEB_BUILD_ARCH).deb
DBG_DEB=$(PACKAGE)-dbgsym_$(DEB_VERSION_UPSTREAM_REVISION)_$(DEB_BUILD_ARCH).deb
DSC=$(PACKAGE)_$(DEB_VERSION_UPSTREAM_REVISION).dsc

DEBS=$(DEB) $(DBG_DEB)

-include /usr/share/pve-doc-generator/pve-doc-generator.mk

all:

.PHONY: dinstall
dinstall: deb
	dpkg -i $(DEB)

qm.bash-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::CLI::qm; PVE::CLI::qm->generate_bash_completions();" >$@.tmp
	mv $@.tmp $@

qmrestore.bash-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::CLI::qmrestore; PVE::CLI::qmrestore->generate_bash_completions();" >$@.tmp
	mv $@.tmp $@

qm.zsh-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::CLI::qm; PVE::CLI::qm->generate_zsh_completions();" >$@.tmp
	mv $@.tmp $@

qmrestore.zsh-completion:
	PVE_GENERATING_DOCS=1 perl -I. -T -e "use PVE::CLI::qmrestore; PVE::CLI::qmrestore->generate_zsh_completions();" >$@.tmp
	mv $@.tmp $@

PKGSOURCES=qm qm.1 qmrestore qmrestore.1 qmextract qm.conf.5 qm.bash-completion qmrestore.bash-completion \
	    qm.zsh-completion qmrestore.zsh-completion cpu-models.conf.5

.PHONY: install
install: $(PKGSOURCES)
	install -d $(DESTDIR)/$(SBINDIR)
	install -d $(DESTDIR)$(LIBDIR)
	install -d $(DESTDIR)/$(MAN1DIR)
	install -d $(DESTDIR)/$(MAN5DIR)
	install -d $(DESTDIR)/usr/share/$(PACKAGE)
	install -m 0644 -D qm.bash-completion $(DESTDIR)/$(BASHCOMPLDIR)/qm
	install -m 0644 -D qmrestore.bash-completion $(DESTDIR)/$(BASHCOMPLDIR)/qmrestore
	install -m 0644 -D qm.zsh-completion $(DESTDIR)/$(ZSHCOMPLDIR)/_qm
	install -m 0644 -D qmrestore.zsh-completion $(DESTDIR)/$(ZSHCOMPLDIR)/_qmrestore
	install -m 0644 -D bootsplash.jpg $(DESTDIR)/usr/share/$(PACKAGE)
	$(MAKE) -C PVE install
	$(MAKE) -C qmeventd install
	$(MAKE) -C query-machine-capabilities install
	$(MAKE) -C qemu-configs install
	$(MAKE) -C vm-network-scripts install
	install -m 0755 qm $(DESTDIR)$(SBINDIR)
	install -m 0755 qmrestore $(DESTDIR)$(SBINDIR)
	install -D -m 0644 modules-load.conf $(DESTDIR)/etc/modules-load.d/qemu-server.conf
	install -m 0755 qmextract $(DESTDIR)$(LIBDIR)
	install -m 0644 qm.1 $(DESTDIR)/$(MAN1DIR)
	install -m 0644 qmrestore.1 $(DESTDIR)/$(MAN1DIR)
	install -m 0644 cpu-models.conf.5 $(DESTDIR)/$(MAN5DIR)
	install -m 0644 qm.conf.5 $(DESTDIR)/$(MAN5DIR)
	cd $(DESTDIR)/$(MAN5DIR); ln -s -f qm.conf.5.gz vm.conf.5.gz

$(BUILDDIR):
	rm -rf $(BUILDDIR) $(BUILDDIR).tmp
	rsync -a * $(BUILDDIR).tmp
	echo "git clone https://github.com/jiangcuo/qemu-server.git\\ngit checkout $(GITVERSION)" > $(BUILDDIR).tmp/debian/SOURCE
	mv $(BUILDDIR).tmp $(BUILDDIR)

.PHONY: deb
deb: $(DEBS)
$(DBG_DEB): $(DEB)
$(DEB): $(BUILDDIR)
	cd $(BUILDDIR); dpkg-buildpackage -b -us -uc
	lintian $(DEBS)

.PHONY: dsc
dsc: $(DSC)
$(DSC): $(BUILDDIR)
	cd $(BUILDDIR); dpkg-buildpackage -S -us -uc -d
	lintian $(DSC)

sbuild: $(DSC)
	sbuild $(DSC)

.PHONY: upload
upload: UPLOAD_DIST ?= $(DEB_DISTRIBUTION)
upload: $(DEB)
	tar cf - $(DEBS) | ssh -X repoman@repo.proxmox.com upload --product pve --dist $(UPLOAD_DIST)

.PHONY: clean
clean:
	rm -rf $(PACKAGE)-*/ *.deb *.build *.buildinfo *.changes *.dsc $(PACKAGE)_*.tar.?z
	rm -f *.xml.tmp *.1 *.5 *.8 *{synopsis,opts}.adoc docinfo.xml


.PHONY: distclean
distclean: clean

=== qemu-configs/Makefile ===
DESTDIR=
USRSHAREDIR=$(DESTDIR)/usr/share/qemu-server

.PHONY: install
install: pve-usb.cfg pve-q35.cfg pve-q35-4.0.cfg pve-port.cfg
	install -d $(USRSHAREDIR)
	install -m 0644 pve-usb.cfg $(USRSHAREDIR)
	install -m 0644 pve-q35.cfg $(USRSHAREDIR)
	install -m 0644 pve-q35-4.0.cfg $(USRSHAREDIR)
	install -m 0644 pve-port.cfg $(USRSHAREDIR)

.PHONY: clean
clean:

=== test/Makefile ===
all: test

test: test_snapshot test_cfg_to_cmd test_pci_addr_conflicts test_qemu_img_convert test_migration test_restore_config

test_snapshot: run_snapshot_tests.pl
	./run_snapshot_tests.pl
	./test_get_replicatable_volumes.pl

test_cfg_to_cmd: run_config2command_tests.pl cfg2cmd/*.conf
	perl -I../ ./run_config2command_tests.pl

test_qemu_img_convert: run_qemu_img_convert_tests.pl
	perl -I../ ./run_qemu_img_convert_tests.pl

test_pci_addr_conflicts: run_pci_addr_checks.pl
	./run_pci_addr_checks.pl

MIGRATION_TEST_TARGETS := $(addprefix test_migration_,$(shell perl -ne 'print "$$1 " if /^\s*name\s*=>\s*["'\'']([^\s"'\'']+)["'\'']\s*,\s*$$/; END { print "\n" }' run_qemu_migrate_tests.pl))

test_migration: run_qemu_migrate_tests.pl MigrationTest/*.pm $(MIGRATION_TEST_TARGETS)

$(MIGRATION_TEST_TARGETS):
	./run_qemu_migrate_tests.pl $(@:test_migration_%=%)

test_restore_config: run_qemu_restore_config_tests.pl
	./run_qemu_restore_config_tests.pl

.PHONY: clean
clean:
	rm -rf MigrationTest/run

=== vm-network-scripts/Makefile ===
DESTDIR=
VARLIBDIR=$(DESTDIR)/var/lib/qemu-server

.PHONY: install
install: pve-bridge pve-bridge-hotplug pve-bridgedown
	install -d ${VARLIBDIR}
	install -m 0755 pve-bridge ${VARLIBDIR}/pve-bridge
	install -m 0755 pve-bridge-hotplug ${VARLIBDIR}/pve-bridge-hotplug
	install -m 0755 pve-bridgedown ${VARLIBDIR}/pve-bridgedown

.PHONY: clean
clean:

=== PVE/API2/Makefile ===
.PHONY: install
install:
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/API2
	install -D -m 0644 Qemu.pm ${DESTDIR}${PERLDIR}/PVE/API2/Qemu.pm
	$(MAKE) -C Qemu install

=== PVE/QemuServer/Makefile ===
SOURCES=PCI.pm		\
	USB.pm		\
	Memory.pm	\
	ImportDisk.pm	\
	Cloudinit.pm	\
	Agent.pm	\
	Helpers.pm	\
	Monitor.pm	\
	Machine.pm	\
	CPUConfig.pm	\
	CGroup.pm	\
	Drive.pm	\
	QMPHelpers.pm

.PHONY: install
install: ${SOURCES}
	for i in ${SOURCES}; do install -D -m 0644 $$i ${DESTDIR}${PERLDIR}/PVE/QemuServer/$$i; done

=== PVE/API2/Qemu/Makefile ===
SOURCES=Agent.pm CPU.pm Machine.pm

.PHONY: install
install:
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/API2/Qemu
	for i in ${SOURCES}; do install -D -m 0644 $$i ${DESTDIR}${PERLDIR}/PVE/API2/Qemu/$$i; done

=== debian/changelog ===
qemu-server (8.3.3+port3) bookworm; urgency=medium

  * Add x86_64 cpu for compatible with x86 host

 -- Jiangcuo <Jiangcuo@lierfang.com>  Fri, 17 Jan 2025 11:57:51 +0800

qemu-server (8.3.3+port2) bookworm; urgency=medium

  * Add 'gicversion' param.

 -- Jiangcuo <Jiangcuo@lierfang.com>  Thu, 26 Dec 2024 12:14:33 +0800

qemu-server (8.3.3+port) bookworm; urgency=medium

  * Add port version

 -- Jiangcuo <Jiangcuo@lierfang.com>  Thu, 26 Dec 2024 12:13:33 +0800

qemu-server (8.3.3) bookworm; urgency=medium

  * fix #5980: import disk: fix spurious warning if no target disk is defined

  * api: clone: always do a full clone of tpmstate volumes

  * swtpm: check that format of tpmstate volume is raw as swtpm currently
    doesn't support anything else anyway.

  * create disk: disallow adding existing non-raw volumes as tpmstate0, like
    as for new volumes.

 -- Proxmox Support Team <support@proxmox.com>  Sun, 15 Dec 2024 14:26:32 +0100

qemu-server (8.3.2+port) bookworm; urgency=medium

  * Add port version

 -- Jiangcuo <Jiangcuo@lierfang.com>  Thu, 26 Dec 2024 11:28:33 +0800

qemu-server (8.3.2) bookworm; urgency=medium

  * use image format from storage layer for PVE-managed volumes

 -- Proxmox Support Team <support@proxmox.com>  Mon, 09 Dec 2024 10:08:14 +0100

qemu-server (8.3.1+port) bookworm; urgency=medium

  * Set default bios type to ovmf when vm create
   
  * Add Kunpeng920 cpu model.

 -- Jiangcuo <Jiangcuo@lierfang.com>  Thu, 26 Dec 2024 11:22:33 +0800

qemu-server (8.3.1) bookworm; urgency=medium

  * api: clone vm: make error for unsupported volumes appear in a
    deterministic order and include the ID of the problematic volume.

  * fix #3588: helper: consider NIC count for config-specific timeout

 -- Proxmox Support Team <support@proxmox.com>  Thu, 05 Dec 2024 12:38:12 +0100

qemu-server (8.3.0+port3) bookworm; urgency=medium

  * Add loongarch efi_vars support

 -- Jiangcuo <jiangcuo@lierfang.com>  Wed, 11 Dec 2024 13:44:37 +0800

qemu-server (8.3.0+port2) bookworm; urgency=medium

  * Fix usb hotplug error

 -- Jiangcuo <jiangcuo@bingsin.com>  Mon, 09 Dec 2024 16:30:48 +0800

qemu-server (8.3.0+port1) bookworm; urgency=medium

  * Fix cpu type on loongarch64

 -- Jiangcuo <jiangcuo@bingsin.com>  Thu, 05 Dec 2024 14:16:44 +0800

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                libpve-cluster-perl,
                libpve-common-perl (>= 8.0.2),
                libpve-guest-common-perl (>= 5.1.0),
-               libpve-storage-perl (>= 8.2.8),
+               libpve-storage-perl (>= 8.2.10),
                libtest-mockmodule-perl,
                liburi-perl,
                libuuid-perl,
@@ -40,7 +40,7 @@
          libpve-cluster-perl,
          libpve-common-perl (>= 8.2.6),
          libpve-guest-common-perl (>= 5.1.2),
-         libpve-storage-perl (>= 8.2.8),
+         libpve-storage-perl (>= 8.2.10),
          libterm-readline-gnu-perl,
          liburi-perl,
          libuuid-perl,
@@ -51,9 +51,10 @@
          pve-edk2-firmware-legacy | pve-edk2-firmware (<< 4~),
          pve-edk2-firmware-ovmf | pve-edk2-firmware (>= 3.20210831-1),
          pve-edk2-firmware-aarch64,
+	  pve-edk2-firmware-loongarch64 [loong64],
          pve-firewall (>= 5.0.4),
          pve-ha-manager (>= 3.0-9),
-         pve-qemu-kvm (>= 7.1~),
+         pve-qemu-kvm (>= 9.0~),
          socat,
          swtpm,
          swtpm-tools,
